/*
 * OCSP responder
 * by Massimiliano Pala (madwolf@openca.org)
 * OpenCA project 2001
 *
 * Copyright (c) 2001 The OpenCA Project.  All rights reserved.
 *
 * ====================================================================
 *
 * This product includes cryptographic software written by Eric Young
 * (eay@cryptsoft.com).  This product includes software written by Tim
 * Hudson (tjh@cryptsoft.com).
 *
 */

// #include <db.h>

/* Functions */

TXT_DB *ocspd_load_db_file(char *dbfile );
char *db_get_revdate( ASN1_INTEGER *serial, OCSPD_CONFIG *conf );
int unpack_revinfo(ASN1_TIME **prevtm, int *preason, ASN1_OBJECT **phold, 
		ASN1_GENERALIZEDTIME **pinvtm, char *str);

int ocspd_verify_cert ( X509_CRL *crl, ASN1_INTEGER *serial );

/* CRL related */
X509_CRL *ocspd_get_crl ( URL *url );
X509_CRL *ocspd_load_crl_file( URL *url );
X509_CRL *ocspd_load_crl_http( URL *url );
X509_CRL *ocspd_X509_CRL_bio ( BIO *in, int form );

STACK_OF(X509) *ocspd_get_ca ( URL *url );
STACK_OF(X509) *ocspd_load_ca_file( URL *url );
STACK_OF(X509) *ocspd_load_ca_http( URL *url );
STACK_OF(CA_ENTRY_CERTID) *ocspd_CA_ENTRY_CERTID_new ( STACK_OF(X509) *ca,
	EVP_MD *dgst );
CA_LIST_ENTRY *ocspd_CA_ENTRY_find ( OCSPD_CONFIG *conf, OCSP_CERTID *cid );
X509_REVOKED *ocspd_X509_REVOKED_find (CA_LIST_ENTRY *ca,ASN1_INTEGER *serial);

STACK_OF(X509_REVOKED) *ocspd_build_crl_entries_list ( CA_LIST_ENTRY *ca,
			X509_CRL *crl );

#ifdef HAVE_OPENLDAP
STACK_OF(X509) *ocspd_load_ca_ldap( URL *url );
X509_CRL *ocspd_load_crl_ldap( URL *url );
#endif

